<!doctype html>
<html lang="en">
<head>
    <title>{{ env.page_title }}</title>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- bootstrap 4 --> <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>
<body>
    <div class="container upsertform_popup">
        <!-- Modal that be triggered by btn w/ class data-toggle="modal" data-target="#upsertform_popup_modalid" -->
        <div class="modal fade" id="upsertform_popup_modalid" tabindex="-1" role="dialog" aria-labelledby="modelTitleId" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">upsert form</h5>

                        <!-- btn x to close the modal -->
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <div class="modal-body">

                        <!--region upsertform -->
                        <div class="row upsertform">
                            <div class="col-sm-0  col-md-1 col-1"></div>

                            <div class="col-sm-12 col-md-10 col-10">{{ upsertform_html |safe }}</div>
                            <!--                                                      |safe so that html code be rendered aka dont--auto-escape -->

                            <div class="col-sm-0  col-md-3 col-1"></div>
                        </div>
                        <!--endregion upsertform -->

                    </div>

                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="button" class="btn btn-danger  btn_del">Delete</button>
                        <button type="button" class="btn btn-primary btn_save">Save</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="container mt-5" style="text-align: right">
        <button type="button" class="btn btn-primary btn_create"
                data-toggle="modal" data-target="#upsertform_popup_modalid" _="these data-xx line trigger modalpopup"
        >Create</button>
    </div>

    <div class="container mt-5">
        <div class="listingtable"></div>  <!-- listingtable will be renedered here by render_listingtable() -->
    </div>

    <!-- jquery      --> <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <!-- bootstrap 4 --> <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
    <!-- axios       --> <script src="https://cdnjs.cloudflare.com/ajax/libs/axios/1.3.2/axios.min.js" integrity="sha512-NCiXRSV460cHD9ClGDrTbTaw0muWUBf/zB/yLzJavRsPNUl9ODkUVmUHsZtKu17XknhsGlmyVoJxLg/ZQQEeGA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

    <!--region handle api request-->
    <!--DONE create RESTFUL_API__xx endpoint w/ mockapi.io -->

    <!--DONE R onload,               call RESTFUL_API/GET_list  to fill listingtable -->
    <!--DONE R on id_col clicked,    call RESTFUL_API/GET_id    to fill popup upsertform at :id        -- at each listingtable row -->
    <!--DONE D on btnDelete clicked, call RESTFUL_API/DELETE_id to delete at :id, reload listingtable  -- in popup upsertform -->
    <!--DONE U on btnSave clicked,   call RESTFUL_API/UPDATE_id to update at :id, reload listingtable  -- in popup upsertform -->
    <!--DONE C on btnSave clicked,   call RESTFUL_API/CREATE to create new row,   reload listingtable  -- in popup upsertform -->

    <script src="./js/index.js"></script>

    <script src="./js/call_api.js"></script>
    <script>const api = new CallAPI('{{ env.RESTFUL_API_URL }}')</script>

    <script>
        let hide_upsertform = () => {
            $('#upsertform_popup_modalid').modal('hide')  // hide bs4 modal ref. https://stackoverflow.com/a/10481634/248616
        }

        let run__render_listingtable = () => {
            api .GET_list()
                .then(res => {
                    console.dir(res.data)  //TODO rm me when done w/ debug
                    let html = render_listingtable(
                        res.data,
                        '{{ env.field_as_id }}',
                        '{{ env.fieldname_list__jsonstr    |safe }}',
                        '{{ env.displayed_as_list__jsonstr |safe }}',
                        //                                 |safe to tell jinja stop auto-escape json str
                    )

                    // render :html to htmldom
                    $('.listingtable').html(html)
                })
                .catch(err => {
                    console.log(err)
                    //TODO also render :err to htmldom
                })
        }

        $(function() {
            //region onload, fetch rows for :listingtable
            run__render_listingtable()
            //endregion onload, fetch rows for :listingtable

            //region btn_create click -> clear :upsertform
            $('.btn_create').click(function(){
                $(`.upsertform [name]`).val('')
            })
            //endregion btn_create click -> clear :upsertform

            // disable :field_as_id input
            $(`.upsertform input[name='{{ env.field_as_id }}']`).attr('disabled', 'disabled')  // jquery to disable input ref. https://stackoverflow.com/a/11540723/248616

            //region btn_save click -> call upsert endpoint
            $('.btn_save').click(function(){
                let fieldval_id = $(`.upsertform input[name='{{ env.field_as_id }}']`).val()

                //region gather reqbody :d from upsertform and call upsert endpoint
                let reqbody = {}
                $(`.upsertform [name]`).each(function(i, elem){
                    reqbody[ $(elem).attr('name') ] = $(elem).val()
                }).promise().done(function(){  // run code wh all .each() done ref. https://stackoverflow.com/a/31357781/248616
                    //region validate fieldval
                    let ok=true

                    //NOTE your data validation goes here

                    if (!ok) return
                    //endregion validate fieldval

                    //region call upsert endpoint
                    let is_insert = (!fieldval_id) === true
                    let is_update = !is_insert

                    if (is_insert) {
                        api .POST(reqbody)
                            .then(res => { run__render_listingtable(); hide_upsertform() } )
                            .catch(err => {
                                console.log(err)
                                //TODO also render :err to htmldom
                            })
                    } else if (is_update) {
                        api .UPDATE(reqbody, fieldval_id)
                            .then(res => { run__render_listingtable(); hide_upsertform() } )
                            .catch(err => {
                                console.log(err)
                                //TODO also render :err to htmldom
                            })
                    } else { throw new Error('Something not right, we should not reach here') }
                    //endregion call upsert endpoint
                })
                //endregion gather reqbody :d from upsertform and call upsert endpoint
            })
            //endregion btn_save click -> call upsert endpoint

            //region btn_del click -> call DELETE endpoint
            $('.btn_del').click(function(){
                let fieldval_id = $(`.upsertform input[name='{{ env.field_as_id }}']`).val()
                api .DELETE(fieldval_id)
                    .then(res => { run__render_listingtable(); hide_upsertform() } )
                    .catch(err => {
                        console.log(err)
                        //TODO also render :err to htmldom
                    })
            })
            //endregion btn_del click -> call DELETE endpoint
        })
    </script>
    <!--endregion handle api request-->

</body>
</html>
